<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.webclient.home.ConfigurationTabs" %>
<%@ page import="com.ibm.itim.authentication.AuthenticationException" %>
<%@ page import="com.ibm.itim.authentication.*" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.exception.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>
<%@ page import="com.ibm.itim.apps.ejb.domain.*" %>
<%@ page import="com.ibm.itim.dataservices.model.*" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="java.lang.reflect.*" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %>
<%@ page import="com.ibm.itim.dataservices.model.system.SystemRole" %>
<%
	
     // Labels and Messages constant
	String DEFINE_ENTITY_TYPE_OPERATIONS = "DEFINE_ENTITY_TYPE_OPERATIONS";
    String ENTITY_TYPE = "ENTITY_TYPE";
    String DEFINE_OPERATIONS = "DEFINE_OPERATIONS";
    String SERVICE_CONFIG = "serviceConfig";
	String UI_CUSTOMIZE = "uiCustomize";
	String SYSADMIN = "sysAdmin";
	String ENTITY_CONFIG = "entityConfig";
    String ENTITY_TYPE_CONFIG = "entityTypeConfig";
	String PROPERTIES = "properties";
	String POLICY_JOIN = "policyJoin";
	String CHALLENGE_RESPONSE = "challengeResponse";
    
    // Get local and message bundle
  	Locale localeObj = (Locale)session.getAttribute("locale");
	if (localeObj == null) {
      		localeObj = Locale.US;
    }
    I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
    I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);
    
    UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request);    	
	int systemRoleCat = userAuthInfo.getSystemRoleCategory();
	if (systemRoleCat < SystemRole.SYSTEMADMIN_CATEGORY) {
		String message = i18NMessage.getMessage("com.ibm.itim.apps.ejb.organization.ACCESS_DENIED");
		request.setAttribute("message", message);
		session.invalidate();
	%>
		<jsp:forward page="/logon"/>
	<%
	} else {

	//	Calling EJBFactory.getHome(...) instead of context lookup. 
	//	For more info ref. devtrack S12664 
	EntityManagerHome entityManagerHome =
			(EntityManagerHome)EJBFactory.getHome("enroleejb.EntityManagerHome",
													com.ibm.itim.apps.ejb.domain.EntityManagerHome.class);

	EntityManager entityManager = entityManagerHome.create();
    	
    String language = LocaleUtil.getLocale(request).toString();
    String languageDirection = I18NMessage.getLanguageDirection(i18NLabel);
    
    // Get variables from request
    String category = request.getParameter("category");
    String categoryLabel = i18NLabel.getMessage("ObjectProfileCategory."+category);
    if (category == null) {
        category = ObjectProfileCategory.PERSON;
        categoryLabel = i18NLabel.getMessage("ObjectProfileCategory.Person");
    }
    //System.out.println("%%%% category = " + category);

    // remove session attributes
    session.removeAttribute("command");
    session.removeAttribute("profileName");
    session.removeAttribute("entityName");
    session.removeAttribute("ldapname");
    session.removeAttribute("category");
    session.removeAttribute("rdnName");
    session.removeAttribute("searchAttribute");
    session.removeAttribute("enroleMap");
    session.removeAttribute("customMap");
    session.removeAttribute("message");
    session.removeAttribute("mode");

    
    //String categories[] = {ObjectProfileCategory.ACCOUNT,ObjectProfileCategory.BPPERSON,ObjectProfileCategory.GLOBAL,ObjectProfileCategory.PERSON};
    String categoryLabels[] = {i18NLabel.getMessage("ObjectProfileCategory.Account"),i18NLabel.getMessage("ObjectProfileCategory.BPPerson"),i18NLabel.getMessage("ObjectProfileCategory.Global"),i18NLabel.getMessage("ObjectProfileCategory.Person")};
    
%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<meta http-equiv="cache-control" content="no-cache">
</head>
<body>
<table name="mainContentTable" cellpadding="0" cellspacing="0" border="0" width="100%">
<!-- For "You are here: path" bar - begin -->
    <tr class="path" width="100%">
        <td colspan="2" class="content" bgcolor="#e7e7cf">
      <table border="0" cellspacing="0" cellpadding="0" height="100%" width="100%">
        <tr>
<td height="1%" valign="top" colspan="3" bgcolor="#cccc99">
        <table name="pathTable" cellpadding="0" cellspacing="0" border="0" width="100%">
          <tr>
            <td background="images/bar_up_bg.gif" valign="top" height="10" colspan="2"><img height="10" width="6" border="0" src="images/bar_upper.gif"></td>
          </tr>

          <tr class="path">
            <td valign="center" width="1" height="16">
              <img src="images/pixel.gif"><img src="images/pixel.gif" width="1" height="20" border="0">
            </td>
            <td class="pathitem" valign="center" height="16" width="400">
                <%
              if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_LTR)) {
%>
			  <%=i18NLabel.getMessage("youAreHere")%>: <%=UIContext.getPathBase (request)%> &gt; <span class="pathfinal"><%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_TYPE_CONFIG)%></span>
<%
              }
              else if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_RTL)) {
%>
              <span class="pathfinal"><%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_TYPE_CONFIG)%></span>
			  &lt; <%=UIContext.getPathBase (request)%> :<%=i18NLabel.getMessage("youAreHere")%>
<%
              }
%>
              
            </td>
          </tr>

          <tr>
            <td background="images/bar_lo_bg.gif" height="10" colspan="2" valign="top"><img height="10" width="6" border="0" src="images/bar_lower.gif"></td>
          </tr>
        </table>
      </td>
    </tr>
<!-- For "You are here: path" bar - end -->
<tr>
<td class="content" height="30"><img border="0" height="15" width="15" src="images/pixel.gif">
<%=i18NLabel.getMessage(DEFINE_ENTITY_TYPE_OPERATIONS)%>   
</td>
<td align="right"><img src="images/pixel.gif" border="0" width="5" height="1">
<a href="
<%out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITY_TYPE_LIST"));%>
"><img name="helpquestion" src="images/question.gif" width="16" height="16" hspace="2" border="0" onmouseover="document.images['helpquestion'].src='images/question_f2.gif';" onmouseout="document.images['helpquestion'].src='images/question.gif';"></a>
</td>
</tr>
</table>
</td>
</tr>
<% 

String tabIndex = request.getParameter("tab_index");
String[] locale = { LocaleUtil.getLocale(request).getLanguage(), LocaleUtil.getLocale(request).getCountry() };

String sessionId = session.getId();

// if no tab index is found in the request, then default to tab '0'
if (tabIndex == null || tabIndex.equals("")) {
   tabIndex = "3";
}
%>

<form name="body">
<input type="hidden" name="target">
<input type="hidden" name="UIContext" value="configuration">
<input type="hidden" name="operation" value="">
<input type="hidden" name="tab_index" value="">
<tr>
<td width="5">&nbsp;&nbsp;</td><td valign="top">
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<br>
</td>
</tr>
<tr>
<td>
    <table cellpadding="0" cellspacing="0" width="100%" border="0">
      <tr>
      <td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('service_profiles_servlet')"><%=i18NLabel.getMessage(SERVICE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('form_designer')"><%=i18NLabel.getMessage(UI_CUSTOMIZE)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
	<table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_role_disp','','admin')"><%=i18NLabel.getMessage(SYSADMIN)%></a></td>
	  </tr>
	</table>
      </td>
      
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight: bold;"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></font></td>
          </tr>
        </table>
      </td>

      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight : bold;" href="javascript:switchToSelectedTabs('entity_list')"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></a></td>
	  </tr>
	</table>
      </td>
      <td class="tabspacer"></td>
      <td align="center">
	<table cellspacing="0" width="100%" border="0">
	  <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_properties')"><%=i18NLabel.getMessage(PROPERTIES)%></a></td>
	  </tr>
	</table>
      </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
      	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('policy_join_directives')"><%=i18NLabel.getMessage(POLICY_JOIN)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
		<td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('challenge_response_config')"><%=i18NLabel.getMessage(CHALLENGE_RESPONSE)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      </tr>
    </table>
  </td>
</tr>
</form>

<tr width="100%">
<td class="content" bgcolor="#e7e7cf"><img border="0" height="5" width="15" src="images/pixel.gif"><br>
</td>
</tr>
<tr bgcolor="e7e7cf">
<td>



   <SCRIPT language=JavaScript>
    <!--
    var message = null;
    
	function defineOperations() {
		//var category = document.forms['frmMain'].elements['category'].value;
        //var profileName = null;
        //var mode = "entitytype";
        document.forms['frmMain'].elements['action'] = "operations.jsp";
        document['frmMain'].submit();
        //showList = window.open("operations.jsp?category=" + category + "&profileName=" + profileName + "&mode=" + mode, "operations", "width=650, height=450, scrollbars=yes");
    }
    //-->
    </SCRIPT>

<!-- JavaScript for Expanding Menus -->
<STYLE type=text/css>.magellanlink {
	COLOR: #FFF; FONT-FAMILY: arial, helvetica, geneva, swiss, sunsans-regular; FONT-SIZE: 9pt; TEXT-DECORATION: underline
}
.magellanlinkhi {
	COLOR: blue; FONT-FAMILY: arial, helvetica, geneva, swiss, sunsans-regular; FONT-SIZE: 9pt; TEXT-DECORATION: underline
}
.magellandiv {
	MARGIN-BOTTOM: 3px
}
</STYLE>

<!--- <center> --->
<form action="" method="POST" enablecab="Yes" name="frmMain">
<input type="hidden" name="command" value="Modify">
<input type="hidden" name="target" value="entity_type">
<input type="hidden" name="profile_dn" value="">
<input type="hidden" name="profileName" value="">
<input type="hidden" name="tab_index" value="3">
<input type="hidden" name="mode" value="entitytype">
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 width="700">
<TR>
	<TD>
		<table cellpadding=1 cellspacing=25 border=0 width="100%" class="formtable">
		<tr>
			<td align="left" colspan="2"><BR>
				<font class="content"><%=i18NLabel.getMessage(ENTITY_TYPE)%></font><br>
                <select name="category"><%
                    String categoryName = null;
                    for (int i=0; i<categoryLabels.length; i++) {
                        categoryName = categoryLabels[i];
                        if (categoryLabels[i].equalsIgnoreCase(categoryLabel)) {%>
                            <option value="<%=categoryName%>" SELECTED><%=categoryName%></option>
                        <%}else{%>
                             <option value="<%=categoryName%>"><%=categoryName%></option>
                        <%}
                    }%>
                </select>
<BR>
            </td>
		</tr>
		        
         <tr>
					<td align="left" colspan="0">
                        <a href="javascript:defineOperations()"><img name="buttondefineoperations" src="<%=language%>/images/buttondefineoperations.gif" hspace="0" alt="<%=i18NLabel.getMessage(DEFINE_OPERATIONS)%>" border="0" onmouseover="document.images['buttondefineoperations'].src='<%=language%>/images/buttondefineoperations_f2.gif';" onmouseout="document.images['buttondefineoperations'].src='<%=language%>/images/buttondefineoperations.gif';"></a>
                    </td>		
		</tr>
   	

		</table>
	</TD>
</TR>



 
</table>
</form>
</table>
</td>
</tr>
</table>

</td>
</tr>
</table>
</body>
</html>
<%}%>
