<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="java.net.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.ejb.organization.account.*" %>
<%@ page import="com.ibm.passwordrules.*" %>
<%@ page import="com.ibm.passwordrules.standard.*" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.webclient.organization.person.SuspendRestorePeopleServlet" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.webclient.util.UserAuthHelper" %>
<%@ page import="com.ibm.itim.dataservices.model.DistinguishedName" %>
<%
  String PASSWORD_RULE_CUE = "passwordRuleCue";
  String MIN_LENGTH = "minLength";
  String MAX_LENGTH = "maxLength";
  String MAX_SEQ_CHARS = "maxSeqChars";
  String MIN_UNIQUE_CHARS = "minUniqueChars";
  String MIN_ALPHA_CHARS = "minAlphaChars";
  String MIN_DIGIT_CHARS = "minDigitChars";
  String INVALID_CHARS= "invalidChars";
  String REQD_CHARS = "reqdChars";
  String RESTRICT_CHARS = "restrictChars";
  String START_CHARS = "startChars";
  String REPEAT_LENGTH = "repeatLength";
  String REVERSE_LENGTH = "reverseLength";
  String USER_NAME_Q = "userName_Q";
  String USER_NAME_CS_Q = "userNameCS_Q";
  String USER_ID_Q = "userID_Q";
  String USER_ID_CS_Q = "userIDCS_Q";
  String IN_DICTIONARY = "inDictionary";
  String MIN_VALID_PERIOD = "minValidPeriod";
  String MAX_VALID_PERIOD = "maxValidPeriod";
  String NOT_SET = "notSet";
  String FALSE = "false";
  String TRUE = "true";
  String RULE = "rule";
  String VALUE = "value";
  String DONE = "doneAlt";

  String LOCALE = "locale";
  Locale localeObj = (Locale)session.getAttribute(LOCALE);
  if (localeObj == null)
    LocaleUtil.getLocale(request);
  if (localeObj == null)
    localeObj = Locale.US;
	String localeDir = localeObj.toString();
	
    I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
%>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet"
          href="<%= localeDir %>/Styles.css"
          type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
    <title>
      enRole
    </title>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0"
    marginwidth="0">
    <table width=100% cellpadding=0 cellspacing=0 border="0">

    <!-- Top Header Row -->
    <tr>
      <td class="topheader">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
    <tr>
      <!-- Header -->
      <td width="400" nowrap="true">
        <br>
      </td>
    </tr>
  </table>
      </td>
    </tr>
    <!-- Content area -->
    <tr>
<td class="path">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
<!-- close header -->

</tr>
</table>
</td>
</tr>
<form accept-charset="UTF-8" method="POST" action="main.jsp" name="body">
<input value="" name="target" type="hidden"><input value="" name="path" type="hidden"><input value="" name="finalPath" type="hidden"><input value="" name="quitURL" type="hidden"><input value="" name="command" type="hidden"><input value="" type="hidden" name="destination"><input value="myEnrole" type="hidden" name="UIContext"><input value="" type="hidden" name="operation"><input value="" type="hidden" name="target_type"><input value="erglobalid=00000000000000000012,ou=0,ou=people,erglobalid=00000000000000000000,dc=com" type="hidden" name="target_dn"><input value="" type="hidden" name="org_dn"><input value="" type="hidden" name="container_dn"><input value="" type="hidden" name="container_type"><input value="" type="hidden" name="request_type"><input value="" type="hidden" name="name"><input value="" type="hidden" name="origin"><input value="" name="tab_index" type="hidden">
<tr>
<td>
<table class="path" cellpadding="4" cellspacing="4" width="100%" border="0">
<tr>
<td class="content"><%=i18NLabel.getMessage(PASSWORD_RULE_CUE)%></td><td align="right"></td>
</tr>
</table>
</td>
</tr>
<!-- check and remove later
<script language="Javascript">
            setTarget('');
</script>
-->
<tr>
<td colspan="2">
<table width="700" border="0" cellspacing="1" cellpadding="3">
<tr class="data">
<td><b class="form"></b></td><td class="form"><input size="" value="change_password" type="hidden" name="pwdAction"></td>
</tr>
<input value="text" type="hidden" name="sortType"><input type="hidden" name="sortBy"><input type="hidden" name="sortOrder"><input value="0" type="hidden" name="pageNo">
<tr>
<td colspan="2">
<table bordercolordark="white" bordercolor="lightgrey" width="100%" border="1" cellspacing="0" cellpadding="1">
<tr>
<td class="tablelabel" nowrap="true"><%=i18NLabel.getMessage(RULE)%>
    &nbsp;
          </td><td class="tablelabel" nowrap="true"><%=i18NLabel.getMessage(VALUE)%>
    &nbsp;
          </td>
</tr>


<!-- data fields start -->
<%!
PasswordRulesInfo passwordRules = null;
%>
<%
      try{
        String serviceDN = request.getParameter("serviceDNforRules");
        PasswordManagerHome passwordManagerHome =
        	(PasswordManagerHome)EJBFactory.getHome(PasswordManagerHome.NAME, PasswordManagerHome.class);
        PasswordManager passwordMgr = passwordManagerHome.create();
        if (serviceDN != null && !serviceDN.equals("")) {
            passwordRules = passwordMgr.getPasswordRulesInfo(new DistinguishedName(serviceDN));
        }else { // from restore person w/ acct restore
            UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request);
            DistinguishedName userDName = new DistinguishedName(userAuthInfo.getUserDN());
            Collection acctDNs = (Collection)session.getAttribute(SuspendRestorePeopleServlet.RESTORE_ACCT_DNS);
            passwordRules = passwordMgr.getCombinedPasswordRuleOnRestore(userDName, acctDNs);
        }
        passwordMgr.remove();
      }catch(Exception e){e.printStackTrace();}
%>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(MIN_LENGTH)%>
        &nbsp;
    </td>
    <%
        int minLng = passwordRules.getMinLength() == -1 ? 0 : passwordRules.getMinLength();
        String minLength = "";
        if (minLng == 0) minLength = i18NLabel.getMessage(NOT_SET);
        else minLength = ""+ minLng;
    %>
    <td class="tablecell"> <%= minLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(MAX_LENGTH)%>
        &nbsp;
    </td>
    <%
        int maxLng = passwordRules.getMaxLength() == -1 ? 0 : passwordRules.getMaxLength();
        String maxLength = "";
        if (maxLng == 0) maxLength = i18NLabel.getMessage(NOT_SET);
        else maxLength = ""+ maxLng;
    %>

    <td class="tablecell"><%= maxLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(MAX_SEQ_CHARS)%>
        &nbsp;
    </td>
    <%
        int maxSeqLng = passwordRules.getMaxSequentialCharacters() == -1 ? 0 : passwordRules.getMaxSequentialCharacters();
        String maxSequentialLength = "";
        if (maxSeqLng == 0) maxSequentialLength = i18NLabel.getMessage(NOT_SET);
        else maxSequentialLength = ""+ maxSeqLng;
    %>

    <td class="tablecell"><%= maxSequentialLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(MIN_UNIQUE_CHARS)%>
        &nbsp;
    </td>
    <%
        int minUnqLng = passwordRules.getMinDistinctCharacters() == -1 ? 0 : passwordRules.getMinDistinctCharacters();
        String minDistinctLength = "";
        if (minUnqLng == 0) minDistinctLength = i18NLabel.getMessage(NOT_SET);
        else minDistinctLength = ""+ minUnqLng;
    %>

    <td class="tablecell"><%= minDistinctLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(MIN_ALPHA_CHARS)%>
        &nbsp;
    </td>
    <%
        int minAlphaLng = passwordRules.getMinAlphabeticCharacters() == -1 ? 0 : passwordRules.getMinAlphabeticCharacters();
        String minAlphaLength = "";
        if (minAlphaLng == 0) minAlphaLength = i18NLabel.getMessage(NOT_SET);
        else minAlphaLength = ""+ minAlphaLng;
    %>

    <td class="tablecell"><%= minAlphaLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(MIN_DIGIT_CHARS)%>
        &nbsp;
    </td>
    <%
        int minNumLng = passwordRules.getMinDigitCharacters() == -1 ? 0 : passwordRules.getMinDigitCharacters();
        String minNumericLength = "";
        if (minNumLng == 0) minNumericLength = i18NLabel.getMessage(NOT_SET);
        else minNumericLength = ""+ minNumLng;
    %>

    <td class="tablecell"><%= minNumericLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(INVALID_CHARS)%>
        &nbsp;
    </td>
    <%
        String invChars = passwordRules.getInvalidChars();
        if (invChars.trim().length() == 0) invChars = i18NLabel.getMessage(NOT_SET);
    %>
    <td class="tablecell"><%= TextUtility.escapeSpecialCharacters(invChars) %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(REQD_CHARS)%>
        &nbsp;
    </td>
    <%
        String reqChars = passwordRules.getRequiredChars();
        if (reqChars.trim().length() == 0) reqChars = i18NLabel.getMessage(NOT_SET);
    %>
    <td class="tablecell"><%= TextUtility.escapeSpecialCharacters(reqChars) %>
        &nbsp;
    </td>
</tr>


<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(RESTRICT_CHARS)%>
        &nbsp;
    </td>
    <%
        String resChars = passwordRules.getRestrictedToChars();
        if (resChars.trim().length() == 0) resChars = i18NLabel.getMessage(NOT_SET);
    %>
    <td class="tablecell"><%= TextUtility.escapeSpecialCharacters(resChars) %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(START_CHARS)%>
        &nbsp;
    </td>
    <%
        String startsWithChars = passwordRules.getStartsWithChars();
        if (startsWithChars.trim().length() == 0) startsWithChars = i18NLabel.getMessage(NOT_SET);
    %>
    <td class="tablecell"><%= TextUtility.escapeSpecialCharacters(startsWithChars) %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(REPEAT_LENGTH)%>
        &nbsp;
    </td>
    <%
        int repHisLng = passwordRules.getRepeatedHistoryLength() == -1 ? 0 : passwordRules.getRepeatedHistoryLength();
        String repHistoryLength = "";
        if (repHisLng == 0) repHistoryLength = i18NLabel.getMessage(NOT_SET);
        else repHistoryLength = ""+ repHisLng;
    %>

    <td class="tablecell"><%= repHistoryLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(REVERSE_LENGTH)%>
        &nbsp;
    </td>
    <%
        int revHisLng = passwordRules.getReversedHistoryLength() == -1 ? 0 : passwordRules.getReversedHistoryLength();
        String revHistoryLength = "";
        if (revHisLng == 0) revHistoryLength = i18NLabel.getMessage(NOT_SET);
        else revHistoryLength = ""+ revHisLng;
    %>

    <td class="tablecell"><%= revHistoryLength %>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(USER_NAME_Q)%>
        &nbsp;
    </td>
    <td class="tablecell"><%=i18NLabel.getMessage((new Boolean(!passwordRules.getAllowUserName())).toString())%>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(USER_NAME_CS_Q)%>
        &nbsp;
    </td>
    <td class="tablecell"><%=i18NLabel.getMessage((new Boolean(!passwordRules.getAllowUserNameCaseInsensitive())).toString())%>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(USER_ID_Q)%>
        &nbsp;
    </td>
    <td class="tablecell"><%=i18NLabel.getMessage((new Boolean(!passwordRules.getAllowUserID())).toString())%>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(USER_ID_CS_Q)%>
        &nbsp;
    </td>
    <td class="tablecell"><%=i18NLabel.getMessage((new Boolean(!passwordRules.getAllowUserIDCaseInsensitive())).toString())%>
        &nbsp;
    </td>
</tr>

<tr class="data">
    <td class="tablecell"><%=i18NLabel.getMessage(IN_DICTIONARY)%>
        &nbsp;
    </td>
    <td class="tablecell"><%=i18NLabel.getMessage((new Boolean(!passwordRules.getAllowInDictionary())).toString())%>
        &nbsp;
    </td>
</tr>

<%
    Map customRules = passwordRules.getCustomRules();
    if (customRules == null) customRules = new HashMap();
		I18NMessage i18NCustomLabel = new I18NMessage(localeObj, I18NMessage.CUSTOM_LABEL_BUNDLE);
    Iterator iter = customRules.keySet().iterator();
    while (iter.hasNext()) {
        String rule = (String)iter.next();
				String label = i18NCustomLabel.getMessage(rule);
%>        
    <tr class="data">
        <td class="tablecell"><%= label %>
            &nbsp;
        </td>
        <%
            String value = (String)customRules.get(rule);
            if (value == null || value.trim().length() == 0) {
              if(PasswordRulesInfo.isRuleTypeTextBox(rule)) {
                %><td class="tablecell"><%= i18NLabel.getMessage(NOT_SET)%>&nbsp;</td><%
              } else {
                  %><td class="tablecell"><%= i18NLabel.getMessage(TRUE) %>&nbsp;</td><%
              }
            } else {
                %><td class="tablecell"><%= TextUtility.escapeSpecialCharacters(value) %>&nbsp;
            <% } %>       
        </td>
    </tr>
<%        
    }
%>

</table>
</td>
</tr>

<!-- data fields end -->



<tr class="bar">
<td colspan="2">
<tr>
<td><a href="javascript:done()" onmouseover="document.images['buttondone'].src='<%= localeDir %>/images/buttondone_f2.gif';" onmouseout="document.images['buttondone'].src='<%= localeDir %>/images/buttondone.gif';"><img vspace="8" hspace="8" name="buttondone" border="0" alt="<%=i18NLabel.getMessage(DONE)%>" src="<%= localeDir %>/images/buttondone.gif"></a></td>
</tr>
</td>
</tr>
</table>
</td>
</tr>
<tr>
<td colspan="2"></td>
</tr>
</form>


  </table>
    <!-- Copyright notice -->
  <table width="100%" border="0" cellpadding="0" cellspacing="0">
      <tr>
        <td width="100%" height="9" bgcolor="cccc99">
    <img src="images/pixel.gif" width="1" height="9" border="0"/></td>
  </tr>
      <tr>
        <td class="copyright">
    <br/> <br/>
        </td>
      </tr>
    </table>
  </body>
</html>



