<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="java.util.Locale" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="com.ibm.itim.webclient.util.UIContext" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %>
<%@ page import="com.ibm.itim.webclient.util.BaseServlet" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>

<%

  String UI_PROPERTIES = "enrole.ui";
  String BUILD_VERSION = "enrole.build.version";
  String buildVersion = "0000";
  // check that user is logged in
    // set the http headers to disable caching
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Pragma", "no-cache");
    response.setDateHeader("Expires", 0);

    // directory for images and other resources
    Locale locale = (Locale)session.getAttribute("locale");
    if (locale == null) {
      locale = LocaleUtil.getLocale(request);
	if(locale == null)
		locale = request.getLocale();
	if (locale == null)
		locale = Locale.US;
    }
    String localeDir = locale.toString();

    ResourceBundle labels = ResourceBundle.getBundle(I18NMessage.LABEL_BUNDLE, locale);
    String title = labels.getString("frameTitle");
    String DONE = "DONE";
    I18NMessage i18NLabel = new I18NMessage(locale, I18NMessage.LABEL_BUNDLE);
    I18NMessage messages = new I18NMessage(locale, I18NMessage.MESSAGE_BUNDLE);
    ResourceBundle err_messages = ResourceBundle.getBundle(I18NMessage.ERRORMESSAGES_BUNDLE, locale);    


    try {
        buildVersion = PropertiesManager.gInstance ().getProperty (
            UI_PROPERTIES, BUILD_VERSION);
        } catch (IOException ioe) {}

    String[] args = new String[]{buildVersion};
    String copyright = messages.getMessage("copyright",args);
%>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">    
    <link rel="stylesheet" href="<%= localeDir %>/Styles.css" type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
    <title>
      <%= title %>
    </title>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0" 
		marginwidth="0"	onLoad="javascript:displayMessage(document);">
        <table cellPadding="0" cellSpacing="0" border="0" width="100%">
            <tr>
                <td><br><br>
                    <font face="helv" size="2">
                    <%
                      if (session.isNew()) {
                      	
		    %>	
		    	<%= err_messages.getString("com.ibm.itim.webclient.util.NavigationHelper.NO_SESSION") %>
		    <% 
		    	session.invalidate();
		      } else {
		        
		    %>  
                        <%=(String)session.getAttribute(BaseServlet.TEST_AGENT_MESSAGE) %>
                    <%  
                      }
                    %>  
                    </font>
                </td>
            </tr>
            <tr><td>&nbsp;</td></tr>
            <tr>
                <td>
                <center><br><a href="javascript:done()" onmouseover="document.images['buttondone'].src='<%= localeDir %>/images/buttondone_f2.gif';" onmouseout="document.images['buttondone'].src='<%= localeDir %>/images/buttondone.gif';">
                    <img vspace="8" hspace="8" name="buttondone" border="0" alt="<%=i18NLabel.getMessage(DONE)%>" src="<%= localeDir %>/images/buttondone.gif"></a>
                </center>
                </td>
            </tr>

        </table>
  </body>
</html>


