<%@ page language="java"%>
<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="javax.ejb.* "%>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.apps.*" %>
<%@ page import="com.ibm.itim.dataservices.model.system.SystemRole" %>
<%@ page import="com.ibm.itim.common.formModel.TextUtility" %>

<%!
	private static final String YOU_ARE_HERE = "youAreHere";
	private static final String COPYRIGHT = "copyright";
	private static final String LANGUAGE = "language";
	private static final String LOCALE = "locale";
	private static final String CHALLENGES_CUE = "crPopupChallengeCue";
	private static final String NUMBER_OF_CHALLENGES = "crNumberOfChallenges";
    private static final String RANDOM_CHALLENGES = "crRandomChallenges";
	private static final String CHALLENGE = "crChallenges";
	private static final String CATEGORY = "category";
	private static final String CONFIG_CHALLENGE_SAVE = "configChallengeSave";
	private static final String ADD_QUESTION = "addQuestion";
	private static final String MODIFY_QUESTION = "modifyQuestion";
	private static final String DELETE_QUESTION = "deleteQuestion";
	private static final String SAVE_QUESTION_LIST = "saveQuestionList";
	private static final String ABORT_ACTIVITY = "abortActivity";
%>

<%
	if (session.isNew()) {
	    response.sendRedirect("/enrole/popUpSessionTimedOut.jsp");
	    return;
	}

	String flag=request.getParameter("addtosession");
	if(flag!=null){
		String [] strings = request.getParameterValues("questionlist");
		List questionList = new Vector();
		for(int i=0; i<strings.length;i++)
			questionList.add(strings[i]);
		session.setAttribute("questionlist",questionList);
	%>	
	<html>
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="expires" content="0">
    	<meta http-equiv="cache-control" content="no-cache">
	    <link rel="stylesheet"
		  href="/Styles.css"
		  type="text/css" title="Styles">
	<title></title>

	<script language="JavaScript">	
	window.close();	
	</script>
	<body>
	</body>
	</html>
	<%	}

	UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request);
	
	String localeDir = (String)session.getAttribute(LANGUAGE);
	if (localeDir == null) {
		localeDir = "en";
    	}

    	Locale localeObj = (Locale)session.getAttribute(LOCALE);
	if (localeObj == null) {
		localeObj = Locale.US;
    	}
    I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
    I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);
    String language = LocaleUtil.getLocale(request).toString();
	int systemRoleCat = userAuthInfo.getSystemRoleCategory();
	if (systemRoleCat < SystemRole.SYSTEMADMIN_CATEGORY) {
		String message = i18NMessage.getMessage("com.ibm.itim.apps.ejb.organization.ACCESS_DENIED");
		request.setAttribute("message", message);
		session.invalidate();
	%>
		<jsp:forward page="/logon"/>
	<%
	} else {
	Context ctx = InitialContextFactory.getInitialContext();

	String challengemode = request.getParameter(CATEGORY);
	if (challengemode == null) challengemode = "0";
	ResourceBundle messages = ResourceBundle.getBundle(I18NMessage.MESSAGE_BUNDLE, localeObj);
    	String copyright = messages.getString(COPYRIGHT);
    	String challengesCue = messages.getString(CHALLENGES_CUE);
	String path = i18NLabel.getMessage(YOU_ARE_HERE) + " : " + UIContext.getPathBase(request);
	String numberOfChallenges = i18NLabel.getMessage(NUMBER_OF_CHALLENGES);
	String randomChallenges = i18NLabel.getMessage(RANDOM_CHALLENGES);
	String challenge = i18NLabel.getMessage(CHALLENGE);
	String helpURL = HelpUtil.getJavaScriptHelpMethod(
	    pageContext.getServletContext(), request, HelpUtil.CONFIGURATION_PASSWDCHALLENGE_DEFINE_QUESTIONS);
%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="stylesheet"
          href="<%= language %>/Styles.css"
          type="text/css" title="Styles">
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="script_library.js"></script>
<title><%=i18NLabel.getMessage("frameTitle")%></title>
<script language="JavaScript">

<!--

function onPWEnter(keypressed) {
    // The Docment Object Model event we need is only available inf Javascript 1.2, MSIE4+ and NN4+
    // This functions is the onKeyPress event handler for the password field
    var key;
    // Test	of MSIE DOM without all that parsing of the agent string
    // NN and MSIE use different DOMs
    if (document.all) {
	key=window.event.keyCode;
    }
    else {
	    key=keypressed.which;
    };
    // Check each key pressed for character code 13 (carriage return), AND
    // then SUBMIT the form for the user
    if (key==13) {
	return false;
    }
}

function setCapture(event) {
	if (!document.all) {
		window.captureEvents(Event.KEYPRESS);
		window.onkeypress = onPWEnter;
	}
}

function relCapture(event) {
	if (!document.all) {
		window.releaseEvents(Event.KEYPRESS);
	}
}

function fillInitialPopupList() {
  var destList = window.document.forms['body'].elements['questionlist'];
  var nUserMustAnswer = window.opener.document.forms['body'].elements['nUserMustAnswer'].value;
  var nRandom = window.opener.document.forms['body'].elements['nRandom'].value;
  var questioncount = 0;

  for (var count = destList.options.length - 1; count >= 0; count--) {
    destList.options[count] = null;
  }

  <% List challengeList=(List)session.getAttribute("questionlist");
     if(challengeList!=null) {
	Iterator ite = challengeList.iterator();
         
	while(ite.hasNext()) {
		String question=(String)ite.next(); 
		String escQuestion=TextUtility.escapeCharacter(question,"\\","\\\\");
		escQuestion=TextUtility.escapeCharacter(escQuestion,"\"","\\\"");%>
		var qsval = "<%=escQuestion%>";
		if (qsval != null && !isSpace(qsval)) {
			destList.options[questioncount] = new Option(qsval, qsval);
			questioncount++;
		}
     <% }
     } %>

  if (window.document.forms['body'].elements['nUserMustAnswer'] != null)
    window.document.forms['body'].elements['nUserMustAnswer'].value = nUserMustAnswer;

  if (window.document.forms['body'].elements['nRandom'] != null)
    window.document.forms['body'].elements['nRandom'].value = nRandom;
}

function addQuestionToList() {
  var question = trim(document.forms['body'].elements['secretquestion'].value);
  if (question != "" && !isSpace(question))  {
      if (question.length <= 240) {
      	var leng = document.forms['body'].elements['questionlist'].length;
      	if (<%= challengemode %> != 0) {
      	    if (leng < 100) {
      	        if (!checkDuplicate(question, leng)){
      		    document.forms['body'].elements['questionlist'].options[leng] =
      		        new Option(question,question);
  	    	    document.forms['body'].elements['secretquestion'].value = "";
  	    	}else{
  	    	    alert(window.opener.document.forms['body'].elements['dcnaHidden'].value);
  	    	}
      	    }else{
      		alert(window.opener.document.forms['body'].elements['clmHidden'].value);
      	    }
      	}else{
      	    if (leng < 5) {
      	        if (!checkDuplicate(question, leng)){
      		    document.forms['body'].elements['questionlist'].options[leng] =
      		        new Option(question,question);
  	    	    document.forms['body'].elements['secretquestion'].value = "";
  	    	}else{
  	    	    alert(window.opener.document.forms['body'].elements['dcnaHidden'].value);
  	    	}
      	    }else{
      		alert(window.opener.document.forms['body'].elements['pllHidden'].value);
      	    }
      	}
     }else{
         alert(window.opener.document.forms['body'].elements['cllHidden'].value);
     }
  }else{
      alert(window.opener.document.forms['body'].elements['ectHidden'].value);
  }
}

function checkDuplicate(question, leng) {
    for (var q=0;q<leng;q++){
        var ques = document.forms['body'].elements['questionlist'].options[q].text;
        if (ques.toLowerCase() == question.toLowerCase()){
       	    return true;
	}
    }
    return false;
}

//trims leading and trailing spaces from the given string
function trim(str)
{
  return( (""+str).replace(/^\s*([\s\S]*\S+)\s*$|^\s*$/,'$1') );
}

function modifyQuestionInList() {
  var listVar = document.forms['body'].elements['questionlist'];
  if (listVar.options.length >= 1 && isSelected(listVar)) {
    if (!isMultipleSelection(listVar)){
    	for(var i = 0; i < listVar.options.length; i++) {
    	  if (listVar.options[i].selected == true) {
	    var question = trim(document.forms['body'].elements['secretquestion'].value);
    	    if (question != "" && !isSpace(question)) {
      		if (question.length <= 240) {
      	            if (!checkDuplicate(question, listVar.options.length)){      		
    	                listVar.options[i].selected = false;
    	                listVar.options[i] = new Option(question, question);
    	                document.forms['body'].elements['secretquestion'].value = "";
         	        break;      	                
  	    	    }else{
  	    	        alert(window.opener.document.forms['body'].elements['dcnaHidden'].value);
         	        break;  	    	        
  	    	    }
    	        }else{
         	    alert(window.opener.document.forms['body'].elements['cllHidden'].value);
       		    break;         	    
    	        }
    	    }
    	  }
        }
    }else{
      alert(window.opener.document.forms['body'].elements['soflmHidden'].value);
    }
  }else{
      alert(window.opener.document.forms['body'].elements['sflmHidden'].value);
  }
}

function deleteQuestionFromList() {
  var listVar = document.forms['body'].elements['questionlist'];
  if (isSelected(listVar)){
    var maxCnt = listVar.options.length;
    for(var i = maxCnt - 1; i >= 0; i--) {
      if ((listVar.options[i] != null) && (listVar.options[i].selected == true)) {
        listVar.options[i] = null;
      }
    }
  }else{
      alert(window.opener.document.forms['body'].elements['sfldHidden'].value);
  }
  document.forms['body'].elements['secretquestion'].value = "";
}

function saveQuestionList() {
  var listVar = document.forms['body'].elements['questionlist'];
  var listLeng = listVar.options.length;
  var questions = "";
  if (listLeng >= 1) {
    var nUserMustAnswer = document.forms['body'].elements['nUserMustAnswer'];
    var nRandom = document.forms['body'].elements['nRandom'];
    if (nUserMustAnswer != null) {
    	var nUserLeng = Number(nUserMustAnswer.value);
    	if (nUserMustAnswer.value != "" && !isSpace(nUserMustAnswer.value)) {
    		if (!isInteger(nUserMustAnswer.value)) {
      		  alert(window.opener.document.forms['body'].elements['piouHidden'].value);
    	  	  return;
    	  	}else if (nRandom == null && (nUserLeng < 1 || nUserLeng > 5)){
      		  alert(window.opener.document.forms['body'].elements['ucnlHidden'].value);
    	  	  return;
    	  	}else if (nRandom != null && (nUserLeng < 1 || nUserLeng > 10)){
      		  alert(window.opener.document.forms['body'].elements['rucnlHidden'].value);
    	  	  return;
    	  	}
    	  	if (listLeng < nUserLeng){
      		  alert(window.opener.document.forms['body'].elements['ungtcHidden'].value);
    	  	  return;
    	  	}
    	}else{
      	  alert(window.opener.document.forms['body'].elements['noceHidden'].value);
    	  return;
    	}
    }

    if (nUserMustAnswer != null && nRandom != null) {
    	var nUserLeng = Number(nUserMustAnswer.value);
    	var nRandLeng = Number(nRandom.value);
    	if (nRandom.value != "" && !isSpace(nRandom.value)) {
    	  if (!isInteger(nRandom.value)) {
      	    alert(window.opener.document.forms['body'].elements['piorHidden'].value);
    	    return;
    	  }else if (nRandLeng < 1 || nRandLeng > 5){
      	    alert(window.opener.document.forms['body'].elements['rnlHidden'].value);
    	    return;
    	  }
    	  if (nUserLeng < nRandLeng) {
      	    alert(window.opener.document.forms['body'].elements['rgtuHidden'].value);
    	    return;
    	  }
    	}else{
      	  alert(window.opener.document.forms['body'].elements['rceHidden'].value);
    	  return;
    	}
    }

    if (window.opener && !window.opener.closed){
      if (nUserMustAnswer != null)
      	window.opener.document.forms['body'].elements['nUserMustAnswer'].value = nUserMustAnswer.value;

      if (nRandom != null)
      	window.opener.document.forms['body'].elements['nRandom'].value = nRandom.value;
    }
    
    for (var i = 0; i < listLeng; i++)
    	listVar.options[i].selected = true;
    document.forms['body'].action = 'challengeQuestionList.jsp?addtosession=true;';
    document.forms['body'].submit();

  }else{
    alert(window.opener.document.forms['body'].elements['aocHidden'].value);
    return;
  }
}

function isInteger(value) {
  for (i=0;i<value.length;i++) {
    var c = value.charAt(i);
    if (!((c >= "0") && (c <= "9")))
      return false;
  }
  return true;
}

function showText() {
  var listVar = document.forms['body'].elements['questionlist'];
  for (var i = 0; i < listVar.options.length; i++) {
    if ((listVar.options[i] != null) && (listVar.options[i].selected == true))
  	document.forms['body'].elements['secretquestion'].value = listVar.options[i].value;
  }
}

function isSelected(varName) {
  for (var i = 0; i < varName.options.length; i++) {
    if (varName.options[i].selected == true)
	return true;
  }
  return false;
}

function isMultipleSelection(varName) {
  var j=0;
  for (var i = 0; i < varName.options.length; i++) {
      if (varName.options[i].selected == true)
        j++;
  }
  if (j > 1) return true;
  return false;
}

function isSpace(string) {
  for (var i=0;i<string.length;i++) {
    charSp = string.charAt(i);   //change variable char
    if (charSp != " ") {
      return false;
    }
  }
  return true;
}
// -->

</script>
</head>
<body onLoad="javascript:fillInitialPopupList();" marginwidth="0" rightmargin="0" topmargin="0" leftmargin="0" bgcolor="white">
	<table width="100%">
		<tr>
			<td>
				<table cellspacing="0" cellpadding="0" border="0" width="100%">
					<tr>
						<td class="copyright">&nbsp;</td>
					</tr>
					<tr>
						<td bgcolor="cccc99" height="9" width="100%"><img border="0" height="9" width="1" src="images/pixel.gif"></td>
					</tr>
				</table>
				<table border="0" width="100%" cellspacing="0" cellpadding="7" class="path">
					<tr>
						<td class="content"><%=i18NLabel.getMessage(CONFIG_CHALLENGE_SAVE)%></td><td nowrap="true" align="right"><img src="images/pixel.gif" border="0" width="5" height="1"><A onmouseout="document.images['helpquestion'].src='images/question.gif';" onmouseover="document.images['helpquestion'].src='images/question_f2.gif';" href="<%= helpURL %>"><img name="helpquestion" height="14" width="16" src="images/question.gif" border="0"></A></td>
					</tr>
				</table>

				<table name="mainContentTable" cellpadding="0" cellspacing="0" border="0" width="100%">
					<form accept-charset="UTF-8" method="POST" action="" name="body">
						<tr bgcolor="ffffff">
							<td>
								<table name="level1" cellspacing="10" bgcolor="#ffffff" width="100%">
									<tr>
										<td>
											<table name="level2" width="100%" bgcolor="#e7e7cf" cellspacing="0" cellpadding="3" border="0">

											<% if (challengemode.equals("1") || challengemode.equals("2")){ %>
												<tr class="data">
													<td width="150" NOWRAP><b class="formlabel"><%= numberOfChallenges %></b></td>
													<td align="right" class="data" width="10">&nbsp;&nbsp;</td>
													<td><font class="formlabel"></font><input name="nUserMustAnswer" size="10" type="text"><font class="formlabel"></font></td>
												</tr>
											<% } %>

											<% if (challengemode.equals("2")){ %>
												<tr class="data">
													<td width="150" NOWRAP><b class="formlabel"><%= randomChallenges %></b></td>
													<td align="right" class="data" width="10">&nbsp;&nbsp;</td>
													<td><font class="formlabel"></font><input name="nRandom" size="10" type="text"><font class="formlabel"></font></td>
												</tr>
											<% } %>
												<tr class="data">
													<td width="100%"><b class="formlabel"><%= challenge %></b></td>
													<td align="right" class="data" width="10">&nbsp;&nbsp;</td>
													<td><font class="formlabel"></font><input name="secretquestion" size="100" type="text"></td>
												</tr>
												<tr class="data">
													<td>&nbsp;</td>
													<td align="right" class="data" width="10">&nbsp;&nbsp;</td>
													<td><font class="formlabel"></font>
														<table bordercolordark="white" bordercolor="lightgrey" width="200" border="1" cellspacing="0" cellpadding="1">
															<tr class="data">
																<td width="100%" align="left">
																	<select multiple="true" name="questionlist" onChange="javascript:showText()" size="10" width="650" style="width:650px" class="picklist" id="multiple">
																	</select>
																</td>
																<td width="100%" align="center">
																	<table width="80%" border="0" cellspacing="0" cellpadding="0">
																		<tr>
																			<td align="center"><a href="Javascript:addQuestionToList()" onmouseover="document.images['buttonadd'].src='<%=language%>/images/buttonadd_f2.gif';" onmouseout="document.images['buttonadd'].src='<%=language%>/images/buttonadd.gif';"><img vspace="8" hspace="8" name="buttonadd" border="0" alt="<%=i18NLabel.getMessage(ADD_QUESTION)%>" src="<%=language%>/images/buttonadd.gif"></a></td>
																		</tr>
																	</table>
																	<table width="80%" border="0" cellspacing="0" cellpadding="0">
																		<tr>
																			<td align="center"><a href="Javascript:modifyQuestionInList()" onmouseover="document.images['buttonmodify'].src='<%=language%>/images/buttonmodify_f2.gif';" onmouseout="document.images['buttonmodify'].src='<%=language%>/images/buttonmodify.gif';"><img vspace="8" hspace="8" name="buttonmodify" border="0" alt="<%=i18NLabel.getMessage(MODIFY_QUESTION)%>" src="<%=language%>/images/buttonmodify.gif"></a></td>
																		</tr>
																	</table>
																	<table width="80%" border="0" cellspacing="0" cellpadding="0">
																		<tr>
																			<td align="center"><a href="Javascript:deleteQuestionFromList();" onmouseover="document.images['buttondelete'].src='<%=language%>/images/buttondelete_f2.gif';" onmouseout="document.images['buttondelete'].src='<%=language%>/images/buttondelete.gif';"><img vspace="8" hspace="8" name="buttondelete" border="0" alt="<%=i18NLabel.getMessage(DELETE_QUESTION)%>" src="<%=language%>/images/buttondelete.gif"></a></td>
																		</tr>
																	</table>
																</td>
															</tr>
														</table>
													</td>
												</tr>
												<tr>
													<td colspan="4">
														<br>
														<center>
														<a href="Javascript:saveQuestionList();" onmouseover="document.images['buttondone'].src='<%=language%>/images/buttondone_f2.gif';" onmouseout="document.images['buttondone'].src='<%=language%>/images/buttondone.gif';"><img name="buttondone" border="0" alt="<%=i18NLabel.getMessage(SAVE_QUESTION_LIST)%>" src="<%=language%>/images/buttondone.gif"></a>
										                    &nbsp;&nbsp;
														<a href="Javascript:window.close();" onmouseover="document.images['buttoncancel'].src='<%=language%>/images/buttoncancel_f2.gif';" onmouseout="document.images['buttoncancel'].src='<%=language%>/images/buttoncancel.gif';"><img name="buttoncancel" border="0" alt="<%=i18NLabel.getMessage(ABORT_ACTIVITY)%>" src="<%=language%>/images/buttoncancel.gif"></a>
														</center>
													</td>
												</tr>
											</table>
										</td>
									</tr>
								</table>
							</td>
						</tr>
					</form>
				</table>
			</td>
		</tr>
	</table>
<table cellspacing="0" cellpadding="0" border="0" width="100%">
<tr>
<td bgcolor="cccc99" height="9" width="100%"><img border="0" height="9" width="1" src="images/pixel.gif"></td>
</tr>
<tr>
<td class="copyright">&nbsp;</td>
</tr>
</table>
<script language="JavaScript1.2">

if (document.layers) {
    if (document.forms['body'] != null) {
	if (document.forms['body'].secretquestion != null) {
	    document.forms['body'].secretquestion.onFocus=setCapture;
	    document.forms['body'].secretquestion.onBlur=relCapture;
	}
    }
}else if (document.forms['body'] != null) {
    if (document.forms['body'].secretquestion != null) {
        document.forms['body'].secretquestion.onkeypress=onPWEnter;
    }
}
</script>

</body>
</html>
<%}%>