<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.authentication.AuthenticationException" %>
<%@ page import="com.ibm.itim.authentication.*" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.exception.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.apps.ejb.domain.*" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="com.ibm.itim.dataservices.model.system.SystemRole" %>
<%
	String SHOW_LDAP_CLASS_TITLE = "Show_Custom_LDAP_Class_List_Title";
    String SELECT_LDAP_CLASS_FROM_LIST = "SELECT_LDAP_CLASS_FROM_LIST";
    String CUSTOM_LDAP_CLASSES = "CUSTOM_LDAP_CLASSES";

    // directory for images and other resources
    Locale locale = (Locale)session.getAttribute("locale");
    if (locale == null) {
      locale = LocaleUtil.getLocale(request);
	if(locale == null)
		locale = request.getLocale();
	if (locale == null)
		locale = Locale.US;
    }
    String localeDir = locale.toString();
    
    I18NMessage i18NLabel = new I18NMessage(locale, I18NMessage.LABEL_BUNDLE);
    I18NMessage i18NMessage = new I18NMessage(locale, I18NMessage.MESSAGE_BUNDLE);
	UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request);
	
	int systemRoleCat = userAuthInfo.getSystemRoleCategory();
		if (systemRoleCat < SystemRole.SYSTEMADMIN_CATEGORY) {
			String message = i18NMessage.getMessage("com.ibm.itim.apps.ejb.organization.ACCESS_DENIED");
			request.setAttribute("message", message);
			session.invalidate();
		%>
			<jsp:forward page="/logon"/>
		<%
	} else {
	
	//	Calling EJBFactory.getHome(...) instead of context lookup. 
	//	For more info ref. devtrack S12664 
	EntityManagerHome entityManagerHome =
			(EntityManagerHome)EJBFactory.getHome("enroleejb.EntityManagerHome",
													com.ibm.itim.apps.ejb.domain.EntityManagerHome.class);
	EntityManager entityManager = entityManagerHome.create();

        Collection objectProfiles = entityManager.getCustomClasses(userAuthInfo);
        TreeSet objectList = null;
        if (objectProfiles != null)
        	objectList = new TreeSet(objectProfiles);
%>

<HTML>
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet" 
          href="<%= localeDir %>/Styles.css" 
          type="text/css" title="Styles">
<TITLE><%=i18NLabel.getMessage(SHOW_LDAP_CLASS_TITLE)%></TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--

function pick(selectedValue) {
  if (window.opener && !window.opener.closed)
    //window.opener.document.frmMain[destValue].value = selectedValue;
    //window.opener.submit("entityConfig.jsp");
    window.opener.setCustomClassName(selectedValue);
  window.close();
}

// -->
</SCRIPT>
</HEAD>
<BODY>
<table bordercolordark="white" bordercolor="lightgrey" width="100%" border="1" cellspacing="0" cellpadding="1">
<tr><td><font class="content"><%=i18NLabel.getMessage(SELECT_LDAP_CLASS_FROM_LIST)%></font></td></tr>
<TR><TD class="path"><font class="tablelabel"><%=i18NLabel.getMessage(CUSTOM_LDAP_CLASSES)%></font></TD></TR>
<%
	if (objectList != null)
	{
		Iterator ite = objectList.iterator();
	        while(ite.hasNext()){
	            String name = (String)ite.next();
	%>		<TR class="tablecell"><TD ><A HREF="javascript:pick('<%=name%>')"><%=name%></A></TD></TR>
	<%	}
	}%>
</TABLE>
</BODY>
</HTML>
<%}%>
