<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.webclient.home.ConfigurationTabs" %>
<%@ page import="com.ibm.itim.authentication.AuthenticationException" %>
<%@ page import="com.ibm.itim.authentication.*" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.exception.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>
<%@ page import="com.ibm.itim.apps.ejb.domain.*" %>
<%@ page import="com.ibm.itim.dataservices.model.*" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="java.lang.reflect.*" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %>
<%@ page import="com.ibm.itim.dataservices.model.system.SystemRole" %>
<%
		
	boolean isEntityInUse = false;
	
	// Labels and Messages constant
	String ADD_AN_ENTITY = "ADD_AN_ENTITY";
	String MODIFY_AN_ENTITY = "MODIFY_AN_ENTITY";
	String ENTER_CUSTOM_ENTITY_NAME = "ENTER_CUSTOM_ENTITY_NAME";
	String NAME_ATTRIBUTE = "NAME_ATTRIBUTE";
	String DEFAULT_SEARCH_ATTRIBUTE = "Default Search Attribute";
	String BROWSE_NAME_ATTRIBUTES = "BROWSE_NAME_ATTRIBUTES";
	String ENROLE_ATTRIBUTES = "ENROLE_ATTRIBUTES";
	String CUSTOM_LDAP_ATTRIBUTES = "CUSTOM_LDAP_ATTRIBUTES";
	String MAPPED_ATTRIBUTES = "MAPPED_ATTRIBUTES";
	String MAP = "MAP";
	String UNMAP = "UNMAP";
	String ENTITY_TYPE = "ENTITY_TYPE";
	String SELECT_ENTITY_TYPE = "SELECT_ENTITY_TYPE";
	String ENTER_CUSTOM_LDAP_CLASS_NAME = "ENTER_CUSTOM_LDAP_CLASS_NAME";
	String BROWSE_LDAP_CLASSES = "BROWSE_LDAP_CLASSES";
	String ADD_ENTITY = "ADD_ENTITY";
	String APPLY_CHANGES = "APPLY_CHANGES";
    String RESET = "RESET";
    String CANCEL = "CANCEL";
	String MISSING_ENTITY_NAME = "MISSING_ENTITY_NAME";
	String MISSING_NAME_ATTRIBUTE = "MISSING_NAME_ATTRIBUTE";
	String MISSING_LDAP_CLASS_NAME = "MISSING_LDAP_CLASS_NAME";
	String CUSTOM_CLASS_NAME_REQUIRED = "CUSTOM_CLASS_NAME_REQUIRED";
	String ENTITY_IN_USE = "ENTITY_IN_USE";
    String DEFINE_OPERATIONS = "DEFINE_OPERATIONS";
	String DEFINE_MAPPING = "DEFINE_MAPPING";
    String ENTITY_ACCOUNT_MAPPING="ENTITY_ACCOUNT_MAPPING";
    String ENTITY_MAPPING="ENTITY_MAPPING";
    String DONE="DONE";
    String SERVICE_CONFIG = "serviceConfig";
	String UI_CUSTOMIZE = "uiCustomize";
	String SYSADMIN = "sysAdmin";
	String ENTITY_CONFIG = "entityConfig";
    String ENTITY_TYPE_CONFIG = "entityTypeConfig";
	String PROPERTIES = "properties";
	String POLICY_JOIN = "policyJoin";
	String CHALLENGE_RESPONSE = "challengeResponse";
    String UI_PROPERTIES = "enrole.ui";
    String BUILD_VERSION = "enrole.build.version";
    String buildVersion = "0000";


	UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request); 
	// Get local and message bundle
    String localeDir = (String)session.getAttribute("language");
	if (localeDir == null) {
	    localeDir = "en";
    }

  	Locale localeObj = (Locale)session.getAttribute("locale");
	if (localeObj == null) {
        localeObj = Locale.US;
    }
    I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
    I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);
		int systemRoleCat = userAuthInfo.getSystemRoleCategory();
		if (systemRoleCat < SystemRole.SYSTEMADMIN_CATEGORY) {
			String message = i18NMessage.getMessage("com.ibm.itim.apps.ejb.organization.ACCESS_DENIED");
			request.setAttribute("message", message);
			session.invalidate();
		%>
			<jsp:forward page="/logon"/>
		<%
	} else {
    	
    // directory for images and other resources
    ResourceBundle labels = ResourceBundle.getBundle(I18NMessage.LABEL_BUNDLE,
            localeObj);
    String title = labels.getString("frameTitle");
    I18NMessage messages = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);

    try {
      buildVersion = PropertiesManager.gInstance ().getProperty (UI_PROPERTIES, BUILD_VERSION);
    } catch (IOException ioe) {}

    String[] args = new String[]{buildVersion};
    String copyright = messages.getMessage("copyright",args);
	String path = labels.getString ("youAreHere") + " : " + UIContext.getPathBase(request);
	String USER_ID = labels.getString("userName");
   	
	//	Calling EJBFactory.getHome(...) instead of context lookup. 
	//	For more info ref. devtrack S12664 
	EntityManagerHome entityManagerHome =
			(EntityManagerHome)EJBFactory.getHome("enroleejb.EntityManagerHome",
													com.ibm.itim.apps.ejb.domain.EntityManagerHome.class);
	EntityManager entityManager = entityManagerHome.create();
    String language = LocaleUtil.getLocale(request).toString();
    String languageDirection = I18NMessage.getLanguageDirection(i18NLabel);
	
	// Get variables from request
    String action = request.getParameter("command");
	String profileName = request.getParameter("profileName");
    String objName = request.getParameter("entityName");
    String ldapname = request.getParameter("ldapname");
    String category = request.getParameter("category");
    //System.out.println("%%%% mapping category = " + category);
    // if category was a translated label from Add Entity panel, get english category name
    if (category != null) {
        if (category.equalsIgnoreCase(i18NLabel.getMessage("ObjectProfileCategory.Person")))
	        category = ObjectProfileCategory.PERSON;
        else if (category.equalsIgnoreCase(i18NLabel.getMessage("ObjectProfileCategory.BPPerson")))
	        category = ObjectProfileCategory.BPPERSON;
    }
    //System.out.println("%%%% mapping category after translation = " + category);
    String rdnName = request.getParameter("rdnName");
    String searchAttribute = request.getParameter("searchAttribute");
    String enroleMapStr = request.getParameter("enroleMap");
	String customMapStr = request.getParameter("customMap");
	String messageStr = request.getParameter("message");
    String mode = request.getParameter("mode");

    // save variables in session
    if (action != null) session.setAttribute("command",action);
    if (profileName != null) session.setAttribute("profileName",profileName);
    if (objName != null) session.setAttribute("entityName",objName);
    if (ldapname != null) session.setAttribute("ldapname",ldapname);
    if (category != null) session.setAttribute("category",category);
    if (rdnName != null) session.setAttribute("rdnName",rdnName);
    if (searchAttribute != null) session.setAttribute("searchAttribute",searchAttribute);
    if (enroleMapStr != null) session.setAttribute("enroleMap",enroleMapStr);
    if (customMapStr != null) session.setAttribute("customMap",customMapStr);
    if (messageStr != null) session.setAttribute("message",messageStr);
    if (mode != null) session.setAttribute("mode",mode);
    
    //System.out.println("%%%% command = " + action);
    //System.out.println("%%%% profileName = " + profileName);
    //System.out.println("%%%% entityName = " + objName);
    //System.out.println("%%%% ldapname = " + ldapname);
    //System.out.println("%%%% category = " + category);
    //System.out.println("%%%% rdnName = " + rdnName);
    //System.out.println("%%%% searchAttribute = " + searchAttribute);
    //System.out.println("%%%% mode = " + mode);
    //System.out.println("%%%% message = " + messageStr);

    int length = enroleMapStr.length();
    //System.out.println("%%%%map enroleMaplength = " + length);

        
    /** check if mapping lists are saved from previous mapping request **/
	boolean savedMap = true;
    if (enroleMapStr == null || enroleMapStr.equals("") || enroleMapStr.equalsIgnoreCase("null")) {
         savedMap = false;
    }
    //System.out.println("%%%%map enroleMap = " + enroleMapStr);
    //System.out.println("%%%%map customMap = " + customMapStr);

    if (enroleMapStr == null) enroleMapStr = "";
	if (customMapStr == null) customMapStr = "";
    //System.out.println("%%%%map enroleMap = " + enroleMapStr);
    //System.out.println("%%%%map customMap = " + customMapStr);
    //System.out.println("%%%%map savedMap = " + savedMap);

    /** check if this is entity or entity type mode **/
	boolean entityMode = false;
	boolean entityTypeMode = false;
    if (mode != null) {
	    if (mode.equalsIgnoreCase("entity"))
			entityMode = true;
		else if (mode.equalsIgnoreCase("entitytype"))
			entityTypeMode = true;
	}


	/** check if it's in modify mode **/
	boolean modifyMode = false;
	boolean addMode = false;
	if (action != null)
	{
		if (action.equalsIgnoreCase("Add"))
			addMode = true;
		else if (action.equalsIgnoreCase("Modify"))
			modifyMode = true;
	}
	
	ObjectProfile objectProfile = null;
	TreeSet ldapAttributes = null;
    Map mapAttributes = null;
    String profile_dn = null;
    
	if (modifyMode && profileName != null)
	{
		objectProfile = entityManager.getDetails(userAuthInfo, profileName);
	}
	
    Collection ldapAttributeList = null;
	
	if (ldapname == null && objectProfile != null)
		ldapname = objectProfile.getCustomClass();
	if (ldapname != null && !ldapname.equals(""))
	{
		ldapAttributeList = entityManager.getAllAttributes(userAuthInfo, ldapname);
		if (ldapAttributeList != null)
			ldapAttributes = new TreeSet(ldapAttributeList);
	}
	
	if (objectProfile != null)
	{
        objName = objectProfile.getName();
        category = objectProfile.getCategory();
        mapAttributes = objectProfile.getAttributeMap();
		profile_dn = objectProfile.getDistinguishedName().toString();
	}
	Collection categories = entityManager.getAllCategory(userAuthInfo);
	
    /** get default attributes **/
	String defaultLdapName = null;
	//String defaultRdnName = null;
	//String defaultSearchAttribute = null;
	ObjectProfile defaultObjectProfile = null;
	Collection defaultLdapAttList = null;
	Map defaultMapAttributes = null;
	if (modifyMode && objName != null)
		defaultObjectProfile = entityManager.getDetails(userAuthInfo, objName);
	if (defaultObjectProfile != null)
	{
		//defaultRdnName = defaultObjectProfile.getNameAttribute();
		//defaultSearchAttribute = defaultObjectProfile.getSearchAttribute();
		defaultLdapName = defaultObjectProfile.getCustomClass();
		defaultMapAttributes = defaultObjectProfile.getAttributeMap();
		profile_dn = defaultObjectProfile.getDistinguishedName().toString();
		isEntityInUse = entityManager.isDataExist(defaultObjectProfile.getTenantDN(), defaultLdapName);
	}
	if (defaultLdapName != null && !defaultLdapName.equals(""))
		defaultLdapAttList = entityManager.getAllAttributes(userAuthInfo, defaultLdapName);
	//System.out.println(isEntityInUse);
%>

<!-- Copyright (c) 2000 by Access360. All Rights Reserved.-->
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet" 
          href="<%= localeObj %>/Styles.css" 
          type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
    <title>
      <%= title %>
    </title>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0" 
		marginwidth="0"	onLoad="javascript:displayMessage(document);">
    <table width=100% cellpadding=0 cellspacing=0 border="0">

    <jsp:include page="/main_menu" flush="true"/>

    <!-- Top Header Row -->
    <tr>
      <td class="topheader">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
	  <tr class="loginname">
	    <!-- Login Name -->
	    <td class="pathfinal" align="right">
			  <img src="images/pixel.gif" border="0" width="1" height="20">
	      <font bgcolor="#cccc99"><%=USER_ID%>:</font>&nbsp;
                <%=((UserAuthInfo)session.getAttribute(UserAuthHelper.USER_AUTH_INFO)).getUserID()%>
	    </td>
	  </tr>
	</table>
      </td>
    </tr>

<tr>
        <td> 
 
<table name="mainContentTable" cellpadding="0" cellspacing="0" border="0" width="100%">
<!-- For "You are here: path" bar - begin -->
<tr class="path" width="100%">
<td colspan="2" class="content" bgcolor="#e7e7cf">
<table border="0" cellspacing="0" cellpadding="0" height="100%" width="100%">

    <tr>
      <td height="1%" valign="top" colspan="3" bgcolor="#cccc99">
        <table name="pathTable" cellpadding="0" cellspacing="0" border="0" width="100%">
          <tr>
            <td background="images/bar_up_bg.gif" valign="top" height="10" colspan="2"><img height="10" width="6" border="0" src="images/bar_upper.gif"></td>
          </tr>

          <tr class="path">
            <td valign="left" width="1" height="16">
              <img src="images/pixel.gif"><img src="images/pixel.gif" width="1" height="20" border="0">
            </td>
            <td class="pathitem" valign="center" height="16" width="500" bgcolor="#e7e7cf">
<%
              if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_LTR)) {
%>
			  <%=i18NLabel.getMessage("youAreHere")%>: <%=UIContext.getPathBase (request)%> &gt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_CONFIG)%> &gt;
              <%=profileName%> &gt; <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_MAPPING)%></span>
<%
              }
              else if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_RTL)) {
%>
              <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_MAPPING)%></span> &lt; <%=profileName%>
			  &lt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_CONFIG)%> &lt; <%=UIContext.getPathBase (request)%> :<%=i18NLabel.getMessage("youAreHere")%>
<%
              }
%>
          </td>
          </tr>

          <tr>
            <td background="images/bar_lo_bg.gif" height="10" colspan="2" valign="top"><img height="10" width="6" border="0" src="images/bar_lower.gif"></td>
          </tr>
        </table>
      </td>
    </tr>

<!-- For "You are here: path" bar - end -->
<tr>
<td class="content" height="30"><img border="0" height="15" width="15" src="images/pixel.gif">
<%
        if (category.equalsIgnoreCase(ObjectProfileCategory.ACCOUNT) || category.equalsIgnoreCase(ObjectProfileCategory.SYSTEM_USER))
            out.println(i18NLabel.getMessage(ENTITY_ACCOUNT_MAPPING));
        else
            out.println(i18NLabel.getMessage(ENTITY_MAPPING));
    %>
</td>
<td align="right"><img src="images/pixel.gif" border="0" width="5" height="1">
<a href="
<%if (addMode) out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITIES_MAPPING_ADD"));
else if (modifyMode) out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITIES_MAPPING_MODIFY"));%>


"><img name="helpquestion" src="images/question.gif" width="16" height="16" hspace="2" border="0" onmouseover="document.images['helpquestion'].src='images/question_f2.gif';" onmouseout="document.images['helpquestion'].src='images/question.gif';"></a>
</td>
</tr>
</table>
</td>
</tr>

<form name="body">
<input type="hidden" name="target">
<input type="hidden" name="UIContext" value="configuration">
<input type="hidden" name="operation" value="">
<input type="hidden" name="tab_index" value="">
<tr>
<td width="5">&nbsp;&nbsp;</td><td valign="top">
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<br>
</td>
</tr>
<tr>
<td>

    <table cellpadding="0" cellspacing="0" width="100%" border="0">
      <tr>
      <td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('service_profiles_servlet')"><%=i18NLabel.getMessage(SERVICE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('form_designer')"><%=i18NLabel.getMessage(UI_CUSTOMIZE)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
	<table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_role_disp','','admin')"><%=i18NLabel.getMessage(SYSADMIN)%></a></td>
	  </tr>
	</table>
      </td>
      
     <%if (entityTypeMode) {%>  
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight: bold;"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></font></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight : bold;" href="javascript:switchToSelectedTabs('entity_list')"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></a></td>
	  </tr>
	</table>
      </td>
      <%}else{%>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('entityTypeConfig.jsp')"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>

      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight : bold;"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></font></td>
	  </tr>
	</table>
      </td>

      <%}%>
      
      <td class="tabspacer"></td>
      <td align="center">
	<table cellspacing="0" width="100%" border="0">
	  <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_properties')"><%=i18NLabel.getMessage(PROPERTIES)%></a></td>
	  </tr>
	</table>
      </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
      	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('policy_join_directives')"><%=i18NLabel.getMessage(POLICY_JOIN)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
		<td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('challenge_response_config')"><%=i18NLabel.getMessage(CHALLENGE_RESPONSE)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      </tr>
    </table>
  </td>
</tr>
</form>

<tr width="100%">
<td class="content" bgcolor="#e7e7cf"><img border="0" height="5" width="15" src="images/pixel.gif"><br>
</td>
</tr>
<tr bgcolor="e7e7cf">
<td>


<% 

String tabIndex = request.getParameter("tab_index");
String[] locale = { LocaleUtil.getLocale(request).getLanguage(), LocaleUtil.getLocale(request).getCountry() };

   String sessionId = session.getId();

   // if no tab index is found in the request, then default to tab '0'
   if (tabIndex == null || tabIndex.equals("")) {
      tabIndex = "3";
   }
%>

<SCRIPT language=JavaScript>
	<!--	
	var message = null;
	<%String message = request.getParameter("message");
	if (message != null && !message.equals(""))
	{%>
	message = "<%=message%>";
	<%}%>
    
	// entity type object with a name and an array of attributes
	function EnEntityType(name, attributes)
	{
		this.name = name;
		this.attributes = attributes;
	}
		
	// entity type object list 
	var enEntityTypeList = new Array();
	<%
	if (action != null)
	{
		Iterator ite = categories.iterator();
		int index = 0;
		while(ite.hasNext()){
			String name = (String)ite.next();
			Collection attributes = entityManager.getEnroleAttributes(userAuthInfo, name);
			if (attributes != null)
			{%>
	var array<%=index%> = new Array();
	<%			Iterator iter = attributes.iterator();
				int attIndex = 0;
				while(iter.hasNext()){
				    String attName = (String)iter.next();%>	    
	array<%=index%>[<%=(attIndex++)%>] = "<%=attName%>";
	<%			}
			}%>
	enEntityTypeList[<%=index%>] = new EnEntityType("<%=name%>", array<%=index++%>);
			
	<%	}
	}%>

	var category = "<%=category%>";
	var mapEnrole = new Array();
	var mapCustom = new Array();
	
    <%if (savedMap)
	{
		StringTokenizer enroleST = new StringTokenizer(enroleMapStr,",");
        StringTokenizer customST = new StringTokenizer(customMapStr,",");
		int index = 0;
		while (enroleST.hasMoreTokens() &&  customST.hasMoreTokens())
		{
			Object key = (Object)enroleST.nextToken();
			String value = (String)customST.nextToken();
	%>	mapEnrole[<%=index%>]="<%=key%>";
		mapCustom[<%=index%>]="<%=value%>";
	<%	index++;
		}
	}else if (defaultMapAttributes != null)
	{
		Set mapKeySet = defaultMapAttributes.keySet();
		Iterator itr = mapKeySet.iterator();
		int index = 0;
		while (itr.hasNext())
		{
			Object key = itr.next();
			String value = (String)defaultMapAttributes.get(key);
	%>	mapEnrole[<%=index%>]="<%=key%>";
		mapCustom[<%=index%>]="<%=value%>";
	<%	index++;
		}
	}%>
	
	function findEntityTypeList(name) {
		for (var i=0; i<enEntityTypeList.length; i++)
		{
			if (name == enEntityTypeList[i].name)
				return i;
		}
		return -1;
	}
	
	function showEnroleAttList() {
        var index = findEntityTypeList("<%=category%>");
        var attributes = enEntityTypeList[index].attributes;
        document.forms['frmMapMain'].elements['enroleAttList'].length = 0;
		document.forms['frmMapMain'].elements['displayList'].length = 0;
		for (var i=0; i<attributes.length; i++)
		{
			var value = attributes[i];
			mapEnrole[i] = value;
			mapCustom[i] = value;
			document.forms['frmMapMain'].elements['enroleAttList'].options[i] = new Option(value, value);
			var mapValue = value + "->" + value;
			document.forms['frmMapMain'].elements['displayList'].options[i] = new Option(mapValue, mapValue);
		}
	}
    
    function showSavedAttList() {
        <%  //System.out.println("%%%% enroleMapStr = " + enroleMapStr);
            //System.out.println("%%%% customMapStr = " + customMapStr);
            StringTokenizer valueToken = new StringTokenizer(enroleMapStr,",");
            StringTokenizer mapToken = new StringTokenizer(customMapStr,",");%>
            document.forms['frmMapMain'].elements['enroleAttList'].length = 0;
		    document.forms['frmMapMain'].elements['displayList'].length = 0;
            <% int i =0;
            while (valueToken.hasMoreTokens() &&  mapToken.hasMoreTokens()) {
                String value = (String)valueToken.nextToken();
                String map = (String)mapToken.nextToken();
                //System.out.println("%%%%1 value = " + value);
                //System.out.println("%%%%1 map = " + map);%>
                var value = <%=value%>;
                mapEnrole[i] = value;
                mapCustom[i] = map;
                document.forms['frmMapMain'].elements['enroleAttList'].options[i] = new Option(value,value);
                var map = <%=map%>;
                var mapValue = value + "->" + map;
			    document.forms['frmMapMain'].elements['displayList'].options[i] = new Option(mapValue, mapValue);
                <% i++;
            }
            while (valueToken.hasMoreTokens()) {
                String value = (String)valueToken.nextToken();
                //System.out.println("%%%%1 value = " + value); %>
                var value = <%=value%>;
                mapEnrole[i] = value;
			    mapCustom[i] = value; 
				document.forms['frmMapMain'].elements['enroleAttList'].options[i] = new Option(value,value);
                var mapValue = value + "->" + value;
			    document.forms['frmMapMain'].elements['displayList'].options[i] = new Option(mapValue, mapValue);
                <% i++;
            }%>

   }

        		
    function findEnroleMapIndex(value)
	{
		for (var i=0; i<mapEnrole.length; i++)
		{
			if (value == mapEnrole[i])
				return i;
		}
		return -1;
	}
	
	function unmap() {
		var enroleIndex = document.forms['frmMapMain'].elements['enroleAttList'].selectedIndex;
		if (enroleIndex != -1)
		{
			var enroleAtt = document.forms['frmMapMain'].elements['enroleAttList'].options[enroleIndex].value;
			var index = findEnroleMapIndex(enroleAtt);
			var displayVal = enroleAtt + "->" + enroleAtt;
			if (index != -1)
			{
				mapCustom[index] = enroleAtt;
				document.forms['frmMapMain'].elements['displayList'].options[index] = new Option(displayVal, displayVal);
			}
			else
			{
				var size = mapEnrole.length;
				mapCustom[size] = enroleAtt;
				mapEnrole[size] = enroleAtt;
				document.forms['frmMapMain'].elements['displayList'].options[document.forms['frmMapMain'].elements['displayList'].options.length] = new Option(displayVal, displayVal);
			}
		}
	}
	
	function map() {
		var enroleIndex = document.forms['frmMapMain'].elements['enroleAttList'].selectedIndex;
		var customIndex = document.forms['frmMapMain'].elements['customAttList'].selectedIndex;
								
		if (enroleIndex != -1 && customIndex != -1)
		{
			var enroleAtt = document.forms['frmMapMain'].elements['enroleAttList'].options[enroleIndex].value;
			var customAtt = document.forms['frmMapMain'].elements['customAttList'].options[customIndex].value;
			var index = findEnroleMapIndex(enroleAtt);
			if (customAtt == "")
				customAtt = enroleAtt;
			var displayVal = enroleAtt + "->" + customAtt;
			if (index != -1)
			{
				mapCustom[index] = customAtt;
				document.forms['frmMapMain'].elements['displayList'].options[index] = new Option(displayVal, displayVal);
			}
			else
			{
				var size = mapEnrole.length;
				mapCustom[size] = customAtt;
				mapEnrole[size] = enroleAtt;
				document.forms['frmMapMain'].elements['displayList'].options[document.forms['frmMapMain'].elements['displayList'].options.length] = new Option(displayVal, displayVal);
			}
		}
	}

	function showArray(array) {
		arraytext = "";
		for (var i=0; i<array.length; i++) {
			arraytext += "Element Index " + i + ":  " + array[i] + "\n";
		}
		document.forms['frmMapMain'].elements['text'].value = arraytext;
	}

	function reset() {
		<%  if (modifyMode && defaultLdapAttList != null) {%>
            document.forms['frmMapMain'].elements['customAttList'].options.length = <%=defaultLdapAttList.size()%>;
			document.forms['frmMapMain'].elements['displayList'].options.length = <%=defaultMapAttributes.size()%>;
			var i = 0;
			var j = 0;
			<%
			if (defaultLdapAttList != null && defaultLdapAttList.size() > 0)
			{
				Iterator iteAttribute = defaultLdapAttList.iterator();
				while(iteAttribute.hasNext()){
				    String attributeName = (String)iteAttribute.next();
			%>		document.forms['frmMapMain'].elements['customAttList'].options[i++] = new Option("<%=attributeName%>","<%=attributeName%>");
			<%	}
			}
			if (defaultMapAttributes != null && defaultMapAttributes.size() > 0)
			{
				Set mapKeySet = defaultMapAttributes.keySet();%>
				mapEnrole.length = <%=defaultMapAttributes.size()%>;
				mapCustom.length = <%=defaultMapAttributes.size()%>;
			<%
				Iterator itr = mapKeySet.iterator();
				while (itr.hasNext()) {
					String key = (String)itr.next();
					String value = (String)defaultMapAttributes.get(key);
					String displayVal = key + "->" + value;
			%>		mapEnrole[j] = "<%=key%>";
					mapCustom[j] = "<%=value%>";
					document.forms['frmMapMain'].elements['displayList'].options[j++] = new Option("<%=displayVal%>", "<%=displayVal%>");
			<%	}
			}
				
		}else {%>
            document.forms['frmMapMain'].elements['customAttList'].options.length = 0;
			showEnroleAttList();
		<%}%>

	}
    
    function submit(target) {
		document.forms['frmMapMain'].elements['action'] = "main.jsp";
		document.forms['frmMapMain'].elements['target'].value = target;
		document.forms['frmMapMain'].elements['command'].value = "<%=action%>";
		document.forms['frmMapMain'].elements['profile_dn'].value = "<%=profile_dn%>";
        document['frmMapMain'].submit();
	}
    
    function done() {
        var enroleString = "";
		var customString = "";
		for (var i=0; i<mapEnrole.length; i++)
		{
			enroleString += mapEnrole[i] + ",";
			customString += mapCustom[i] + ",";
		}
        document.forms['frmMapMain'].elements['enroleMap'].value = enroleString;
		document.forms['frmMapMain'].elements['customMap'].value = customString;
        
        //document.forms['frmMapMain'].elements['action'] = "entityConfig.jsp";
        //document['frmMapMain'].submit();
        submit("entityConfig.jsp");
        
        //if (window.opener && !window.opener.closed)
        //    window.opener.document.frmMapMain['enroleMap'].value = enroleString;
        //    window.opener.document.frmMapMain['customMap'].value = customString;
        //window.close();
	}
	
	function cancel() {
        document.forms['frmMapMain'].elements['action'] = "entityConfig.jsp";
        document['frmMapMain'].submit();
        //window.close();
	}
    
    

    //-->
</script>

<!-- JavaScript for Expanding Menus -->
<STYLE type=text/css>.magellanlink {
	COLOR: #FFF; FONT-FAMILY: arial, helvetica, geneva, swiss, sunsans-regular; FONT-SIZE: 9pt; TEXT-DECORATION: underline
}
.magellanlinkhi {
	COLOR: blue; FONT-FAMILY: arial, helvetica, geneva, swiss, sunsans-regular; FONT-SIZE: 9pt; TEXT-DECORATION: underline
}
.magellandiv {
	MARGIN-BOTTOM: 3px
}
</STYLE>

<!--- <center> --->
<form action="" method="POST" enablecab="Yes" name="frmMapMain">
<input type="hidden" name="target" value="entityConfig.jsp">
<input type="hidden" name="command" value="<%=action%>">
<input type="hidden" name="profile_dn" value="">
<input type="hidden" name="tab_index" value="3">
<input type="hidden" name="enroleMap" value="<%=enroleMapStr%>">
<input type="hidden" name="customMap" value="<%=customMapStr%>">
<input type="hidden" name="message" value="<%=messageStr%>">


	
<!--- 1 --->
		<table cellpadding=0 cellspacing=0 border=1 width="100%">	
		<tr class="formtable">
			<td class="formtable">
				<!--- begin: HEADER RECORD TABLE --->
				<table cellpadding=3 cellspacing=1 border=0 width="100%">
				
				<tr>
					<td align="center" width="50%"><font size=-1 face="Arial,Helvetica"><font class="content"><%=i18NLabel.getMessage(ENROLE_ATTRIBUTES)%></font></td>
					<td></td>
					<td align="center" width="50%"><font size=-1 face="Arial,Helvetica"><font class="content"><%=i18NLabel.getMessage(CUSTOM_LDAP_ATTRIBUTES)%></font></td>
					<td align="center" width="50%"><font size=-1 face="Arial,Helvetica"><font class="content"><%=i18NLabel.getMessage(MAPPED_ATTRIBUTES)%></font></td>					
				</tr>
				<TR>
					<TD align="center" >
					
					<select name="enroleAttList" size="12" width="200">
					<% if (modifyMode)
					{
                        Collection attributes = entityManager.getEnroleAttributes(userAuthInfo, category);
						Iterator itr = attributes.iterator();
						while(itr.hasNext())
						{
							String value = (String)itr.next();%>
							<option value="<%=value%>"><%=value%></option>
						<%}
					} else if ((addMode) && (savedMap))
					{
                        StringTokenizer st = new StringTokenizer(enroleMapStr,",");
                        while (st.hasMoreTokens())
                        {
                            String value = (String)st.nextToken();%>
							<option value="<%=value%>"><%=value%></option>
						<%}
					}%>

					</select>
					</TD>
					
					<td>
                    <%if (category.equalsIgnoreCase(ObjectProfileCategory.ACCOUNT) || category.equalsIgnoreCase(ObjectProfileCategory.SYSTEM_USER)) {
					    // don't put map/unmap buttons
				    } else {%>
                        <a href="javascript:map()"><img name="buttonMap" src="<%=language%>/images/buttonmap.gif" hspace="2" alt="<%=i18NLabel.getMessage(MAP)%>" border="0" onmouseover="document.images['buttonMap'].src='<%=language%>/images/buttonmap_f2.gif';" onmouseout="document.images['buttonMap'].src='<%=language%>/images/buttonmap.gif';"></a>
					    <br>
					    <a href="javascript:unmap()"><img name="buttonUnMap" src="<%=language%>/images/buttonunmap.gif" hspace="2" alt="<%=i18NLabel.getMessage(UNMAP)%>" border="0" onmouseover="document.images['buttonUnMap'].src='<%=language%>/images/buttonunmap_f2.gif';" onmouseout="document.images['buttonUnMap'].src='<%=language%>/images/buttonunmap.gif';"></a>
					<%}%>
                    </td>
					
					<TD align="center" >
					<select name="customAttList" size="12" width="200">
					<%
                    if (ldapAttributes != null && ldapAttributes.size() > 0)
					{
						Iterator iteAttribute = ldapAttributes.iterator();
					    while(iteAttribute.hasNext()){
					        String attributeName = (String)iteAttribute.next();%>
                            <option value="<%=attributeName%>"><%=attributeName%></option>
						<%}
					} else if ((addMode) && (savedMap))
					{
                        StringTokenizer st = new StringTokenizer(customMapStr,",");
                        while (st.hasMoreTokens())
                        {
                            String value = (String)st.nextToken();%>
							<option value="<%=value%>"><%=value%></option>
						<%}
					}           
					else {%>
					<option>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
					</option>
					<%}%>
					</select>
					</TD>
					
					<TD align="center" >
					<select name="displayList" size="12" width="200">			
                    <%  if (savedMap)
					{
                        //System.out.println("%%%%2 enroleMap = " + enroleMapStr);
                        //System.out.println("%%%%2 customMap = " + customMapStr);
                        StringTokenizer enroleST = new StringTokenizer(enroleMapStr,",");
                        StringTokenizer customST = new StringTokenizer(customMapStr,",");
                        int index =0;
                        while (enroleST.hasMoreTokens() &&  customST.hasMoreTokens())
                        {
                            String key = (String)enroleST.nextToken();
                            String value = (String)customST.nextToken();
                            //System.out.println("%%%%2 key = " + key);
                            //System.out.println("%%%%2 value = " + value);
                            %>
							<option value="<%=index%>"><%=(key + "->" + value)%></option>
                            <% index++;
                        }
                        while (enroleST.hasMoreTokens())
                        {
                            String key = (String)enroleST.nextToken();
                            //System.out.println("%%%%3 key = " + key);
                            %>
                            <option value="<%=index%>"><%=(key + "->" + key)%></option>
                            <% index++;
                        }

					} else if (defaultMapAttributes != null)
					{
							Set mapKeySet = defaultMapAttributes.keySet();
							Iterator itr = mapKeySet.iterator();
							int index = 0;
							while (itr.hasNext())
							{
								Object key = itr.next();
								String value = (String)defaultMapAttributes.get(key);%>
                                <option value="<%=index%>"><%=(key + "->" + value)%></option>
                                <% index++;
							}
					}%>
					</select>
					</TD>

				</TR>
				</table>
				<!--- end: REQUEST SUBMITTED TABLE --->
			</td>
		</tr>
		</table>
<!--- 1 --->
	
 
<tr>
	<td>
		<table cellpadding=1 cellspacing=0 border=0 width="100%" class="formtable">
		<tr>
			<td height="30" align="center">
			<table border="0" cellpadding="0" cellspacing="0" >
				<td ALIGN="center">
				<a href="javascript:done();"><img name="buttonDone" src="<%=language%>/images/buttondone.gif" hspace="2" alt="<%=i18NLabel.getMessage(DONE)%>" border="0" onmouseover="document.images['buttonDone'].src='<%=language%>/images/buttondone_f2.gif';" onmouseout="document.images['buttonDone'].src='<%=language%>/images/buttondone.gif';"></a>
                </td>
			</table>
			</td>
		</tr>
		</table>
	</td>
</tr>	
</table>
</form>

</table>
</td>
</tr>
</table>
</td>
</tr>
</table>

<tr>
        <td>
            <!-- Copyright notice -->
	        <table width="100%" border="0" cellpadding="0" cellspacing="0">
                <tr>
                    <td width="100%" height="9" bgcolor="cccc99"><img src="images/pixel.gif" width="1" height="9" border="0"/></td>
	            </tr>
                <tr>
                    <td class="copyright">
	                    <%=copyright%>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
 </table>
   
 </body>
</html>


<script language=javascript>
<!--

<% if (mapAttributes == null && addMode &&!savedMap) {%>
showEnroleAttList();
<%}%>
if (message != null&& message != "")
{
alert(message);
document.forms['frmMapMain'].elements['message'].value = "";
}
//-->
</script>
</BODY>
</html>
<%}%>
