<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.ibm.itim.webclient.util.UIContext" %>
<%@ page import="com.ibm.itim.webclient.util.UnicodeUtil" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %>
<%@ page import="com.ibm.itim.webclient.util.BaseServlet" %>

<%
  // check that user is logged in
    // set the http headers to disable caching
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Pragma", "no-cache");
    response.setDateHeader("Expires", 0);
    //directory for images and other resources
    Locale locale = (Locale)session.getAttribute("locale");
    if (locale == null) {
      locale = LocaleUtil.getLocale(request);
	if(locale == null)
		locale = Locale.US;
    }
    String localeDir = locale.toString();
    
    I18NMessage messages = new I18NMessage(locale, I18NMessage.ERRORMESSAGES_BUNDLE);
    String message = UnicodeUtil.escapeUnicode(messages.getMessage("main.jsp.sessionTimeout"));
    session.invalidate();
%>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet" href="<%= localeDir %>/Styles.css" type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
	<script language="JavaScript">
		function timedOutMessage (document) {
			//window.opener.document.location = "/enrole/logon?message=<%= message %>";
            window.opener.document.forms['body'].submit();
			alert(document.forms['popWindowForm'].Message.value);
    		window.close();
			window.opener.focus();
		}	
	</script>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0" marginwidth="0" onLoad="javascript:timedOutMessage(document);">
  	<form name="popWindowForm" action="" method="post">
		<input name="Message" value=<%="'" + messages.getMessage(BaseServlet.POP_UP_TIMED_OUT_MSG) + "'"%> type="hidden">
        <table cellPadding="0" cellSpacing="0" border="0" width="100%">
            <tr>
                <td><br><br>
                    <center><font face="helv" size="2">
		    		<%= messages.getMessage(BaseServlet.POP_UP_TIMED_OUT_MSG) %>
                    </font></center>
                </td>
            </tr>
            <tr><td>&nbsp;</td></tr>
            <tr>
                <td>
                <center><br><br><a href="javascript:done()" onmouseover="document.images['buttondone'].src='<%= localeDir %>/images/buttondone_f2.gif';" onmouseout="document.images['buttondone'].src='<%= localeDir %>/images/buttondone.gif';">
                    <img vspace="8" hspace="8" name="buttondone" border="0" alt="Done" src="<%= localeDir %>/images/buttondone.gif"></a>
                </center>
                </td>
            </tr>
        </table>
	</form>
  </body>
</html>
